import 'package:flutter/material.dart';
import 'package:libcli/log/log.dart' as log;
import 'package:libcli/log/color.dart';

const _here = 'wait_notifier';

enum AsyncStatus { wait, ready, error }

abstract class AsyncProvider with ChangeNotifier {
  AsyncStatus asyncStatus = AsyncStatus.wait;

  String errorMessage;

  /// prevent notifyListeners after dispose
  bool _disposed = false;

  /// load return true if load successfully and need set errorMessage before return false
  ///
  Future<bool> load() async {
    return false;
  }

  @override
  notifyListeners() {
    if (!_disposed) {
      super.notifyListeners();
    }
  }

  @override
  void dispose() {
    log.debug(_here, 'dispose $runtimeType');
    _disposed = true;
    super.dispose();
  }
}
