import 'package:flutter/material.dart';
import 'package:libcli/log/log.dart' as log;
import 'package:libcli/log/color.dart';
import 'package:libui/async/async_provider.dart';

const _here = 'wait_provider';

class AwaitProvider with ChangeNotifier {
  List<AsyncProvider> list;

  AsyncStatus status() {
    for (var p in list) {
      if (p.asyncStatus == AsyncStatus.wait) {
        return AsyncStatus.wait;
      } else if (p.asyncStatus == AsyncStatus.error) {
        return AsyncStatus.error;
      }
    }
    return AsyncStatus.ready;
  }

  List<String> errorMessage() {
    List<String> messages = List<String>();
    for (var p in list) {
      if (p.asyncStatus == AsyncStatus.error) {
        messages.add((p.errorMessage));
      }
    }
    return messages;
  }

  void reload() {
    list.forEach((provider) {
      if (provider.asyncStatus == AsyncStatus.error) {
        provider.asyncStatus == AsyncStatus.wait;
      }

      if (provider.asyncStatus == AsyncStatus.wait) {
        Future.microtask(() {
          provider.load().then((ok) {
            provider.asyncStatus = ok ? AsyncStatus.ready : AsyncStatus.error;
            provider.notifyListeners();
          }).catchError((e, s) {
            log.error(_here, e, s);
            provider.asyncStatus = AsyncStatus.error;
          });
        });
      }
    });
  }
}
