import 'dart:async';
import 'dart:convert';
import 'package:libui/assets/assets.dart' as assets;
import 'package:meta/meta.dart';
import 'package:libui/i18n/i18n_state.dart';
import 'package:libui/i18n/i18n.dart' as i18n;

class I18nModel {
  String _key;

  Future<void> read( String pageName,String localeID) async {
    var key = '${pageName}_$localeID';
    if (_key != key) {
      String jsonContent = await assets.get('i18n/${key}.json');
      var localization = json.decode(jsonContent);
      i18n.state = I18nState(localization);
      _key = key;
    }
  }

  /// mockInit Initializes the value for testing
  ///
  ///     I18nModel.mockInit('{"title": "mock"}');
  ///
  @visibleForTesting
  static void mockInit(String map) {
    Future<String> mockLoad(fileName) async {
      return map;
    }

    assets.get = mockLoad;
  }
}
