import 'package:libcli/log/log.dart' as log;
import 'package:libui/i18n/i18n.dart' as i18n;

class I18nState {
  final Map<String, dynamic> _localization;
  I18nState(this._localization);

  String translate(String key) {
    var value = _localization[key];
    if (value == null) {
      log.alert('i18n', 'missing "$key" in ${i18n.pageName}_${i18n.localeID}');
      return '!!! $key not found';
    }
    return value;
  }
}
